function [] = updateGui()
%UPDATEGUI Summary of this function goes here
%   Detailed explanation goes here

global artoaGui artoaWorkspace;

if ~isfield(artoaWorkspace, 'trackParameter') ...
        || ~isfield(artoaGui.figures, 'trackParameter') ...
        || ~isvalid(artoaGui.figures.trackParameter)
    return;
end

% % update soundsources
% artoaGui.trackParameter.tableSoundSourceOffsets.RowName = fieldnames( ...
%     artoaWorkspace.filteredSoundsources ...
% );

fields = artoaWorkspace.trackParameter;
fieldNames = fieldnames(fields);

for i = 1:length(fieldNames)
    currentValue = fields.(fieldNames{i});
    switch fieldNames{i}
        case 'dopplerCorrection'
            artoaGui.trackParameter.checkboxDopplerCorrection.Value = currentValue;
        case 'plotResiduals'
            artoaGui.trackParameter.checkboxPlotResiduals.Value = currentValue;
        case 'trackingMethodValue'
            artoaGui.trackParameter.comboboxTrackingMethod.Value = currentValue;
        case 'interpolationMethodValue'
            artoaGui.trackParameter.comboboxInterpolationMethod.Value = currentValue;
        case 'soundspeedMethodValue'
            artoaGui.trackParameter.comboboxSoundspeedMethod.Value = currentValue;
        case 'outputInterpolationInterval'
            artoaGui.trackParameter.inputOutputInterpolationInterval.String = currentValue;
        case 'gapSize'
            artoaGui.trackParameter.inputGapSize.String = currentValue;
        case 'soundsourceOffsets'
            artoaGui.trackParameter.tableSoundSourceOffsets.Data = ...
                artoa.soundsources.createOffsetsCell( ...
                currentValue, ...
                artoaGui.trackParameter.tableSoundSourceOffsets.RowName ...
            );
        case 'soundsourceCombinations'
            artoaGui.trackParameter.tableSoundSourceCombinations.Data = artoa.soundsources.createCombinationsCell(currentValue);
        case 'floatOffsetBegin'
            artoaGui.trackParameter.inputFloatOffsetBegin.String = currentValue;
        case 'floatOffsetEnd'
            artoaGui.trackParameter.inputFloatOffsetEnd.String = currentValue;
    end
end

end

